%global namedversion %{version}%{?namedreltag}

Name:          jackson-module-jaxb-annotations
Version:       2.3.0
Release:       2%{?dist}
Epoch:         0
Summary:       JAXB annotations support for Jackson (2.x)
License:       ASL 2.0
Group:         Development/Libraries
URL:           http://wiki.fasterxml.com/JacksonJAXBAnnotations
Source0:       https://github.com/FasterXML/jackson-module-jaxb-annotations/archive/%{name}-%{version}.tar.gz
# jackson-module-jaxb-annotations package don't include the license file
# https://github.com/FasterXML/jackson-module-jaxb-annotations/issues/21
Source1:       http://www.apache.org/licenses/LICENSE-2.0.txt

BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: fasterxml-oss-parent >= 0:11
BuildRequires: jackson-core >= 0:2.3.0
BuildRequires: jackson-databind >= 0:2.3.0
BuildRequires: jboss-jaxb-api_2.2_spec

# test deps
BuildRequires: jsr311-api
BuildRequires: junit >= 0:4.10

BuildRequires: build-helper-maven-plugin >= 0:1.7
BuildRequires: doclava >= 0:1.0.3
BuildRequires: jsilver >= 0:1.0.0
BuildRequires: maven-bundle-plugin >= 0:2.3.7
BuildRequires: maven-compiler-plugin
BuildRequires: maven-deploy-plugin
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-replacer-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-scm-plugin >= 0:1.7
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: surefire-junit4

BuildArch:     noarch
BuildRoot:     %{_tmppath}/%{name}-%{namedversion}-%{release}-root

Requires: jboss-jaxb-api_2.2_spec
Requires: fasterxml-oss-parent >= 0:11
Requires: jackson-core = %{epoch}:%{version}
Requires: jackson-databind = %{epoch}:%{version}
Requires: jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils

%description
Support for using JAXB annotations as an alternative to
"native" Jackson annotations, for configuring data binding.

%package -n %{name}-javadoc
Summary: Javadoc for %{name}
Group:   Documentation
BuildRequires: jpackage-utils
Requires: jpackage-utils

%description -n %{name}-javadoc
%{summary}.

%prep
# GitHub puts the project name in twice when creating a tarball.
%setup -q -n %{name}-%{name}-%{version}

%{__cp} -p %{SOURCE1} .
%{__sed} -i 's/\r//' LICENSE-2.0.txt
%pom_remove_dep javax.xml.bind:jaxb-api
%pom_add_dep org.jboss.spec.javax.xml.bind:jboss-jaxb-api_2.2_spec

%build
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://${PWD}/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -B -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip deploy javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

#jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/com/fasterxml/jackson/module/%{name}/%{namedversion}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/module/%{name}/%{namedversion}/%{name}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/module/%{name}/%{namedversion}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
pushd %{buildroot}%{_javadir}
for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done
popd

#poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/com/fasterxml/jackson/module/%{name}/%{namedversion}/%{name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom

#depmaps
%add_maven_depmap

#javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt README.md release-notes/*
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{namedversion}.jar
%{_javadir}/%{name}-javadoc.jar
%{_javadir}/%{name}-%{namedversion}-javadoc.jar
%{_javadir}/%{name}-sources.jar
%{_javadir}/%{name}-%{namedversion}-sources.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files -n %{name}-javadoc
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%changelog
* Thu Dec 19 2013 Alex Wood <awood@redhat.com> 0:2.3.0-2
- Correct Group to use standard value.

* Tue Dec 17 2013 Alex Wood <awood@redhat.com> 0:2.3.0-1
- Initial packaging.
